//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2011, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#include <Trade\Trade.mqh> 
#include <Trade\AccountInfo.mqh> 
#include <for_t101.mqh>          
#property version   "1.0"



double Lots=0.1;                      //     
input double stop=-1000.0;             //         
input double _profit=3000.0;             //        
input ENUM_TIMEFRAMES TF_for_find=PERIOD_D1;  // ,    
input int shift_start_history=1;      // ,     

CTrade trade;                         //   CTrade
CAccountInfo acc_info;
array_all_val W0;
bool _trade;
bool last_trade_up=false,last_trade_down=false;
bool setup_for_sell=false,setup_for_buy=false;
string setup_for_sell_up="",setup_for_sell_dn="";
string setup_for_buy_up="",setup_for_buy_dn="";
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+

void OnInit()
  {
   _trade=true;

   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void OnTick()
  {
   if(PositionsTotal()==0 && !_trade){return;}

   SymbolInfoDouble("GBPUSD",SYMBOL_BID);
   SymbolInfoDouble("EURGBP",SYMBOL_BID);
   SymbolInfoDouble("GBPCHF",SYMBOL_BID);
   SymbolInfoDouble("CHFJPY",SYMBOL_BID);
   SymbolInfoDouble("AUDJPY",SYMBOL_BID);
   SymbolInfoDouble("EURJPY",SYMBOL_BID);
   SymbolInfoDouble("USDCHF",SYMBOL_BID);
//---buy
   SymbolInfoDouble("CADJPY",SYMBOL_BID);
   SymbolInfoDouble("AUDUSD",SYMBOL_BID);
   SymbolInfoDouble("USDJPY",SYMBOL_BID);
   SymbolInfoDouble("EURUSD",SYMBOL_BID);
   SymbolInfoDouble("EURCHF",SYMBOL_BID);
   SymbolInfoDouble("GBPJPY",SYMBOL_BID);
   SymbolInfoDouble("USDCAD",SYMBOL_BID);

   if(AccountInfoDouble(ACCOUNT_BALANCE)<5000){_trade=false;}

   Write_struct(W0,TF_for_find,shift_start_history);

   int gr_count_0_6=0,rd_count_7_13=0,rd_count_0_6=0,gr_count_7_13=0;
   bool Buy_Condition=false,Sell_Condition=false;
   for(int y=0;y<7;y++)
     {
      //Print(y," ",W0.c_color[y]);
      if(W0.c_color[y]==clrGreen){gr_count_0_6++;}
      if(W0.c_color[7+y]==clrRed){rd_count_7_13++;}
      if(W0.c_color[7+y]==clrGreen){rd_count_0_6++;}
      if(W0.c_color[y]==clrRed){gr_count_7_13++;}
     }

   if(gr_count_0_6==7 && rd_count_7_13==7)
     {
      if(!setup_for_sell) //  
        {

         setup_for_sell=true;
         setup_for_sell_up=W0.s_name[0];
         setup_for_sell_dn=W0.s_name[13];
         //Print("=sell================",setup_for_sell_up," ",setup_for_sell_dn);
        }
     }

   if(setup_for_sell && !last_trade_down) // 
     {

      Sell_Condition=(W0.s_name[0]!=setup_for_sell_up && W0.s_name[13]!=setup_for_sell_dn);
      //Print("=====sell=======run=========",setup_for_sell_up," ",setup_for_sell_dn," = ",W0.s_name[0]," ",W0.s_name[13]," ",Sell_Condition);
     }
   if(rd_count_0_6==7 && gr_count_7_13==7)
     {
      if(!setup_for_buy) //  
        {

         setup_for_buy=true;
         setup_for_buy_up=W0.s_name[0];
         setup_for_buy_dn=W0.s_name[13];
         //Print("========================================Buy================",setup_for_buy_up," ",setup_for_buy_dn);
        }
     }
   if(setup_for_buy && !last_trade_up) // 
     {
      ///Print("======================================Buy=======run==========",setup_for_buy_up," ",setup_for_buy_dn," = ",W0.s_name[0]," ",W0.s_name[13]);
      Buy_Condition=(W0.s_name[0]!=setup_for_buy_up && W0.s_name[13]!=setup_for_buy_dn);
     }

   static double sl=stop;
   if(PositionsTotal()==0){last_trade_up=false;last_trade_down=false;}
//if (TimeCurrent()>StringToTime("2012.03.19 12:10")){Close();}

   if(Buy_Condition && !last_trade_up && _trade)
     {
      //Print("======================================Buy=======run===trade=======",W0.s_name[0]," ",W0.s_name[13]);
      Close();
      Open_trade(0,0.1);
      last_trade_up=true;
      last_trade_down=false;
      sl=stop;
      setup_for_buy=false;
      //Print("======================================Buy ok");
     }
   if(Sell_Condition && !last_trade_down && _trade)
     {
      //Print("======================================Sell=======run===trade=======",W0.s_name[0]," ",W0.s_name[13]);
      Close();
      Open_trade(1,0.1);
      last_trade_up=false;
      last_trade_down=true;
      sl=stop;
      setup_for_sell=false;
      //Print("======================================Sell ok");
     }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   if(acc_info.Profit()<sl || acc_info.Profit()>_profit)
     {
      //Print("======================================Close");
      Close();
      last_trade_up=false;
      last_trade_down=false;
      setup_for_sell=false;
      setup_for_buy=false;
     }

   return;
  }
//+------------------------------------------------------------------+

void Open_trade(int  type,double inlot)
  {
   bool ok;
   string name_val[14]={"GBPUSD","EURGBP","GBPCHF","CHFJPY","AUDJPY","EURJPY","GBPJPY","CADJPY","AUDUSD","USDJPY","EURUSD","EURCHF","USDCHF","USDCAD"};
   int i;
   int a,b,c,d;
   if(type==1){a=12;b=14;c=0;d=12;}
   if(type==0){a=0;b=12;c=12;d=14;}

   for(i=a;i<b;i++)
     {
      if(AccountInfoDouble(ACCOUNT_FREEMARGIN)>1000) //       
        {
         ok=trade.PositionOpen(name_val[i],
                               ORDER_TYPE_BUY,//   
                               inlot,//    
                               SymbolInfoDouble(name_val[i],SYMBOL_ASK),//   ask 
                               0.0,// Stop Loss
                               0.0,// Take Profit 
                               "exp");
         if(!ok && trade.ResultRetcode()!=10008){i--;}
        }
      else
        {return;}
     }
   for(i=c;i<d;i++)
     {
      if(AccountInfoDouble(ACCOUNT_FREEMARGIN)>1000) //       
        {
         ok=trade.PositionOpen(name_val[i],
                               ORDER_TYPE_SELL,//   
                               inlot,//    
                               SymbolInfoDouble(name_val[i],SYMBOL_BID),//   ,bid 
                               0.0,// Stop Loss
                               0.0,// Take Profit 
                               "exp");
         if(!ok && trade.ResultRetcode()!=10008){i--;}
        }
      else
        {return;}
     }
  }
//+------------------------------------------------------------------+
void Close()
  {
   bool ok;
   string name_val[14]={"USDCAD","EURGBP","GBPCHF","CHFJPY","AUDJPY","EURJPY","GBPJPY","CADJPY","AUDUSD","USDJPY","EURUSD","EURCHF","USDCHF","GBPUSD"};
   int i;
   for(i=14-1;i>=0;i--)
      //+------------------------------------------------------------------+
      //|                                                                  |
      //+------------------------------------------------------------------+
     {
      //if(PositionSelect(name_val[i]))
        {
         ok=trade.PositionClose(name_val[i],-1);
         //if(!ok){i++;}
        }

      //Print("-close-","i=",i,"    ",name_val[i],GetLastError());

     }
   return;
  }
//+------------------------------------------------------------------+
